<div>
  <h4 class="form-group p-mb-5">
    Vacation report
  </h4>

  <h5 class="form-group">
    1. General information
  </h5>
  <div class="form-group d-flex justify-content-start p-mb-5">
    <p-table [scrollable]="true" [autoLayout]="true" [value]="[{}]">
      <ng-template pTemplate="body">
        <tr class="table-row">
          <td class="header text-right" style="min-width:350px">Employment date</td>
          <td *ngIf="(!employmentDate && !showEditDate) || isTMEmployee">Not started as FT yet<ng-template [ngTemplateOutlet]="editEmploymentTime"></ng-template></td>
          <td *ngIf="employmentDate && !showEditDate && !isTMEmployee">{{employmentDate | date: 'MM/dd/yyyy'}}
          <td *ngIf="showEditDate" class="employment-date-cell">
              <p-calendar [(ngModel)]="employmentDateModel" [minDate]="minDate" [maxDate]="maxDate" [locale]="globals.calendarLocale" [style]="{ width: '100%' }"
                [inputStyle]="{ width: '100%' }" selectionMode="single" appendTo="body" [showButtonBar]="true" [firstDayOfWeek]="1"></p-calendar>
                <button pButton icon="fa fa-check" (click)="onNewEmploymentDateConfirm()"></button>
                <button pButton *ngIf="employmentDateWritePermission" icon="fa fa-ban" (click)="onCancelEmploymentDate()" class="p-button-warning"></button>
          </td>
        </tr>
        <tr *ngIf="terminationDate" class="table-row">
          <td class="header text-right" style="min-width:350px">Termination date</td>
          <td>{{!!terminationDate ? (terminationDate | date : 'MM/dd/yyyy') : null}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:350px">
            Standing, years
            <i class="fa fa-question-circle" (mouseenter)="standingYearsOp.show($event)" (mouseleave)="standingYearsOp.hide()"></i>
          </td>
          <td>{{standingYears | number : '1.0-2'}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:350px">Transferred vacation balance</td>
          <td>{{transferredBalance | number : '1.2-2'}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:350px">Minimum allowed balance (vacation credit)</td>
          <td>{{minimumAllowedBalance | number : '1.2-2'}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:350px">
            Days in reserve (this year)
            <i class="fa fa-question-circle" (mouseenter)="reserveDaysOp.show($event)" (mouseleave)="reserveDaysOp.hide()"></i>
          </td>
          <td>{{reportedReserveDays | number : '1.0-1'}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:350px">
            Days in reserve (last 6m)
            <i class="fa fa-question-circle" (mouseenter)="lastSixMonthsReserveDaysOp.show($event)" (mouseleave)="lastSixMonthsReserveDaysOp.hide()"></i>
          </td>
          <td>{{reportedReserveDaysForLastSixMonths | number : '1.0-1'}}</td>
        </tr>
      </ng-template>
    </p-table>
  </div>

  <p-overlayPanel #standingYearsOp>
    <div class="limit-overlay-container">
      <app-limit-progress
        [value]="standingYears"
        [maxLimit]="nextBreakpoint?.threshold || currentBreakpoint.threshold"
        unit="years"
        label="Standing years"
        defaultMessage="You receive {{ currentBreakpoint.annualVacations }} vacation days per year"
        progressState="success"
      ></app-limit-progress>
      <div>
        <div>
          @for (item of breakpoints; track $index) {
            <div>
              <ng-container *ngIf="!!item">
                <span *ngIf="!!item.message;else breakpointMessage">  {{item.annualVacations}} days - {{item.message}}</span>
                <ng-template #breakpointMessage>
                  <span>  {{item.annualVacations}} days - {{item.threshold}}+ years of total work experience in Leobit</span>
                </ng-template>
              </ng-container>
            </div>
          }
        </div>
      </div>
    </div>
  </p-overlayPanel>

  <p-overlayPanel #reserveDaysOp>
    <div class="limit-overlay-container">
      <app-limit-progress
        [value]="reportedReserveDays"
        [maxLimit]="20"
        unit="days"
        label="Vacation transfer breakpoint"
        defaultMessage="Up to 5 days can be transferred to the next year"
        maxLimitExceededMessage="No vacation days will be transferred to the next year"
      ></app-limit-progress>
      <div class="mb-2">
        <i class="fa fa-info-circle"></i>
        Upon reaching a breakpoint of 20 full days in reserve, your unused vacation days will not be transferred to next year's balance
      </div>

      <app-limit-progress
        [value]="reportedReserveDays"
        [maxLimit]="reserveDaysBreakpoint"
        unit="days"
        label="Mandatory vacation breakpoints"
        defaultMessage="You haven't reached any breakpoints yet"
        intermediateLimitExceededMessage="You've reached a total of {{reachedReserveBreakpoints}} breakpoints"
        [progressState]="reserveDaysBreakpoint > 15 ? 'warning' : 'success'"
      ></app-limit-progress>
      <div>
        <i class="fa fa-info-circle"></i>
        For every 15 days spent in reserve, you may be required to spend up to 5 days of vacation (but not more than your current balance allows)
      </div>
    </div>
  </p-overlayPanel>

  <p-overlayPanel #lastSixMonthsReserveDaysOp>
    <div class="limit-overlay-container">
      <app-limit-progress
        [value]="reportedReserveDaysForLastSixMonths"
        [intermediateLimit]="5"
        [maxLimit]="20"
        unit="days"
        label="Vacation compensation breakpoint"
        defaultMessage="All unspent vacation days can be compensated"
        intermediateLimitExceededMessage="Only up to 5 unspent vacation can be compensated"
        maxLimitExceededMessage="No unspent vacation days can be compensated"
      ></app-limit-progress>
      <div>
        <i class="fa fa-info-circle"></i>
        In case of leaving the company, up to 5 unspent vacation days will be compensated if more than 5 days in reserve were reported for the last 6 months. If more than 20 days were reported, no days will be compensated
      </div>
    </div>
  </p-overlayPanel>


  <div class="form-group d-flex justify-content-between align-items-center">
    <h5 class="mb-0" style="display: inline-block;">
      2. Vacation accrual/used, days:
    </h5>
    <div *ngIf="customDayOffWritePermission">
      <p-button *ngIf="!customDayOffs?.length && allCustomDayOffs?.length" icon="fa fa-list-ul" label="List of all days off"
        class="ml-3" (click)="showHistoryAllDialog()"></p-button>
      <p-splitButton *ngIf="customDayOffs?.length" icon="fa fa-list-ul" label="List user dayoffs" class="ml-3"
        (onClick)="showHistoryDialog()" [model]="customDayOffMenu"></p-splitButton>
      <p-button icon="fa fa-plus" label="Add a day off" class="ml-3" (click)="onAddCustomDayOff()"></p-button>
    </div>
  </div>
  <div class="form-group p-mb-5">
    <p-table [scrollable]="true" [autoLayout]="true" [value]="[{}]">
      <ng-template pTemplate="header">
        <tr>
          <th *ngFor="let column of columns">
            {{column}}
          </th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body">
        <tr class="table-row">
          <td class="header text-right">
            Accrual
          </td>
          <td *ngFor="let accrual of accrualDays; let i = index"
            [ngClass]="{ 'highlighted': isPastMonth(i), 'nonzero': accrual.value > 0, 'positive': isMonthCustomsCountPositive(i) === 'Positive', 'negative': isMonthCustomsCountPositive(i) === 'Negative' }">
            {{accrual.value | number : '1.2-2'}}
          </td>
          <td class="header">
            {{totalAccrual | number : '1.2-2'}}
          </td>
        </tr>

        <tr class="table-row">
          <td class="header text-right">
            Used
          </td>
          <td *ngFor="let used of usedDays; let i = index"
            [ngClass]="{ 'highlighted': isPastMonth(i), 'nonzero': used.value > 0 }">
            {{used.value | number : '1.2-2'}}
          </td>
          <td class="header">
            {{totalUsed | number : '1.2-2'}}
          </td>
        </tr>
      </ng-template>
    </p-table>
  </div>

  <p-dialog *ngIf="customDayOffWritePermission && customDayOffDialogModel.isVisible"
    header="{{ customDayOffDialogModel.action === 1 ? 'Add' : 'Edit' }} day off"
    [(visible)]="customDayOffDialogModel.isVisible" [responsive]="true" [resizable]="false" showEffect="fade"
    [modal]="true" [style]="{ 'width': '530px' }">
    <app-edit-custom-day-off [(customDayOffDialogModel)]="customDayOffDialogModel" (onConfirm)="onSaveCustomDayOff()"
      [forbiddenMonths]="assignedMonths">
    </app-edit-custom-day-off>
  </p-dialog>

  <p-dialog *ngIf="customDayOffs?.length" [(visible)]="historyDialogVisible" [responsive]="true" [resizable]="false"
    [focusOnShow]="false" showEffect="fade" [modal]="true" [style]="{ 'width': '800px' }"
    [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }"
    header="Selected User Custom Days Off">
    <p-table [scrollable]="true" [value]="customDayOffs" [autoLayout]="true">
      <ng-template pTemplate="header">
        <tr>
          <th style="width: 90px"></th>
          <th>Year</th>
          <th>Month</th>
          <th>Extra Day Off</th>
          <th>Editor</th>
          <th *ngIf="customDayOffWritePermission" style="width: 100px"></th>
        </tr>
      </ng-template>

      <ng-template pTemplate="body" let-cdo>
        <tr>
          <td>
            <button pButton label="More" (click)="onCustomDayOff(cdo.id)" class="p-button-success"></button>
          </td>
          <td>{{cdo.year}}</td>
          <td>{{globals.calendarLocale.monthNames[cdo.month - 1]}}</td>
          <td>{{cdo.extraDayOff}}</td>
          <td>{{cdo.lastEditorFullName}}</td>
          <td *ngIf="customDayOffWritePermission">
            <div class="d-flex justify-content-between">
              <button pButton icon="fa fa-pencil" (click)="onEditCustomDayOff(cdo.id)"
                class="p-button-warning"></button>
              <button pButton icon="fa fa-times" (click)="onDeleteCustomDayOff(cdo.id)"
                class="p-button-danger"></button>
            </div>
          </td>
        </tr>

        <tr *ngIf="selectedCustomDayOffId === cdo.id">
          <td colspan="6">
            <p-table [scrollable]="true" [value]="selectedCustomDayOff" [autoLayout]="true">
              <ng-template pTemplate="header">
        <tr>
          <th>Editor</th>
          <th>Last Edited</th>
          <th>Description</th>
        </tr>
      </ng-template>
      <ng-template pTemplate="body" let-cdoDetails>
        <tr>
          <td>{{cdo.lastEditorFullName}}</td>
          <td>{{cdoDetails.lastEditTimestamp | date:'dd/MM/yyyy HH:mm:ss'}}</td>
          <td>{{cdoDetails.description}}</td>
        </tr>
      </ng-template>
    </p-table>
    </td>
    </tr>
    </ng-template>
    </p-table>
  </p-dialog>

  <p-dialog [(visible)]="historyAllDialogVisible" [responsive]="true" [resizable]="false" [focusOnShow]="false"
    showEffect="fade" [modal]="true" [style]="{ 'width': '1000px' }"
    [contentStyle]="{ 'max-height': 'calc(100vh - 200px)', 'overflow-y': 'auto' }" header="All Custom Days Off">
    <p-table [scrollable]="true" [value]="allCustomDayOffs" [autoLayout]="true">
      <ng-template pTemplate="header">
        <tr>
          <th>Month</th>
          <th>User</th>
          <th>Extra Day Offs</th>
          <th>Description</th>
          <th>Editor</th>
          <th>Last Edited</th>
          <th class="buttons"></th>
        </tr>
      </ng-template>

      <ng-template pTemplate="body" let-cdo>
        <tr>
          <td>{{globals.calendarLocale.monthNames[cdo.month - 1]}}</td>
          <td>{{cdo.userFullName}}</td>
          <td>{{cdo.extraDayOff}}</td>
          <td>{{cdo.description}}</td>
          <td>{{cdo.lastEditorFullName}}</td>
          <td>{{cdo.lastEditTimestamp | date}}</td>
          <td>
            <div class="d-flex justify-content-between">
              <button pButton icon="fa fa-pencil" (click)="onEditCustomDayOff(cdo.id)"
                class="p-button-warning"></button>
              <button pButton icon="fa fa-times" (click)="onDeleteCustomDayOff(cdo.id)"
                class="p-button-danger"></button>
            </div>
          </td>
        </tr>
      </ng-template>
    </p-table>
  </p-dialog>

  <h5 class="form-group">
    3. Vacation balance, days:
  </h5>
  <div class="form-group d-flex justify-content-start p-mb-5">
    <p-table [scrollable]="true" [autoLayout]="true" [value]="[{}]">
      <ng-template pTemplate="body">
        <tr class="table-row">
          <td class="header text-right" style="min-width:300px">Transferred vacation balance</td>
          <td>{{transferredBalance | number : '1.2-2'}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:300px">Accrued to date</td>
          <td>{{accrualToDate | number : '1.2-2'}}</td>
        </tr>
        <tr *ngIf="extraDaysOff != 0" class="table-row">
          <td class="header text-right" style="min-width:300px">Extra day offs</td>
          <td>{{extraDaysOff | number : '1.2-2'}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:300px">Used to date</td>
          <td>{{totalUsed | number : '1.2-2'}}</td>
        </tr>
        <tr *ngIf="compensatedVacationLeftovers != 0" class="table-row">
          <td class="header text-right" style="min-width:300px">Paid before T&M</td>
          <td>{{compensatedVacationLeftovers | number : '1.2-2'}}</td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:300px">Current vacation balance</td>
          <td><b>{{currentVacationBalance | number : '1.2-2'}}</b></td>
        </tr>
        <tr class="table-row">
          <td class="header text-right" style="min-width:300px">Expected EOY vacation balance</td>
          <td>{{expectedEoyVacationBalance | number : '1.2-2'}}</td>
        </tr>
        <tr class="table-row ">
          <td class="header text-right" style="min-width:300px">Vacation credit</td>
          <td>{{minimumAllowedBalance | number : '1.2-2'}}</td>
        </tr>
        <tr class="table-row ">
          <td class="header text-right" style="min-width:300px">Available vacation (with credit)</td>
          <td><b>{{availableVacation | number : '1.2-2'}}</b>
          </td>
        </tr>
      </ng-template>
    </p-table>
  </div>

</div>

<ng-template #editEmploymentTime><button pButton *ngIf="employmentDateWritePermission"  style="margin-left: 5px" icon="fa fa-pencil" (click)="onEditEmploymentDate()"></button></ng-template>
